<template>

  <div class="contenido">
    
     <vue-headful title="Hack a Flight | Clientes" />
     <ClientTable/>
      <ClientTable v-on:datos="mostrarInfoCliente" :clientes="clientes" v-on:borrar="borrandoCliente" />

      <!--Modal para actualizar cliente-->
      <div v-show="seeModal" class="modal">
        <div class="modalBox">
          <h3>
            Actualiza los datos de tu cliente:
          </h3>
          <p>
            ID del Cliente: {{ idCliente }}
          </p>
          <input type="text" placeholder="Nombre del cliente" v-model="nombreActualizado"><br>
          <input type="text" placeholder="Usuario" v-model="usuarioActualizado"><br>
          <input type="text" placeholder="Password" v-model="contrasenaActualizada"><br>
          <input type="text" placeholder="e-mail" v-model="emailActualizada"><br>
          <button @click="seeModal =! seeModal">
            Cancelar
          </button>
          <button @click="actualizarCliente()">
            Actualizar cliente
          </button>
      </div>
      </div>
  </div>
</template>

<script>
import axios from 'axios';
import vueHeadful from 'vue-headful';
import ClientTable from '@/components/ClientTable.vue';
import Swal from "sweetalert2";
export default {
  name: 'Clientes',
  components: {
    ClientTable
  },
  data(){
    return{
      clientes: [],
      idCliente: '',
      nombreActualizado: '',
      usuarioActualizado: '',
      contrasenaActualizada: '',
      emailActualizada: '',
      fotoActualizada: '',
      seeModal: false
    }
  },
  methods: {
    borrandoCliente(indiceCliente){
      var self = this;
      axios.delete('http://localhost:3308/delete/' + indiceCliente, {
      })
      .then( function(response) {
        console.log(response)
      })
      .catch( function (error) {
        console.log(error)
      } )
      location.reload()
    },
    actualizarCliente(){
      var self = this;
      axios.put('http://localhost:3308/update/' + self.idCliente, {
        nombre: self.nombreActualizado,
        usuario: self.usuarioActualizado,
        contrasena: self.contrasenaActualizada,
        email: self.emailActualizada,
        foto: self.fotoActualizada
      })
      .then( function(response) {
        console.log(response)
      })
      .catch( function (error) {
        console.log(error)
      } )
      location.reload()
    },
    mostrarInfoCliente(datosCliente){
      this.nombreActualizado = datosCliente.nombre
      this.usuarioActualizado = datosCliente.usuario
      this.contrasenaActualizada = datosCliente.contrasena
      this.emailActualizada = datosCliente.email
      this.fotoActualizada = datosCliente.foto
      this.idCliente = datosCliente.id

      this.seeModal = true
    },
    // FUNCIÓN PARA CONSEGUIR MIS CLIENTES
    getClients(){
      var self = this;

      // LLAMADA DE AXIOS A LA API
      axios.get('http://localhost:3308/clientes')
      .then( function(response) {
        self.clientes = response.data
      })
      .catch( function (error) {
        console.log(error)
      } )
    }
  },
  created() {
    this.getClients()
  }

}

</script>


<style scoped>
@import url('https://fonts.googleapis.com/css2?family=Source+Sans+Pro:wght@200&display=swap');

.contenido {
font-family: 'Source Sans Pro', sans-serif;
font-size: 26px;
padding-top: 150px;
display:block;
margin:auto;
text-align: center;
}
.modal {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  width: 100%;
  background: rgba(0, 0, 0, 0.5);
}
.modalBox {
  background-color: #fefefe;
  margin: 2%auto;
  padding: 3rem;
  width: 50%;
  border: 1px solid #888;
  text-align: center;
}
div{
  text-align: center;
}

ul {
  text-align: left;
  list-style: none;
  padding-inline-start: 0px;
}

li{
  line-height: auto;
}
.title {
  grid-area: d;
  text-align: center;
}
.item1 {
  grid-area: a;
  text-align: left;
  padding: 15px;
  background-color: whitesmoke;

}
.item2 {
  grid-area: b;
}
.centrado{
  text-align: center;
  width: 400px;
}

input{
  padding:8px;
  font-size: 26px;
  display:block;
  border:none;
  border-bottom:1px solid #ccc;
  width:400px
  }

button {
  font-size: 26px;
  background-color: black;
  color: white;
  padding: 20px 40px;
  margin: 20px 10px;
  border: none;
  cursor: pointer;
}

button:hover {
  opacity: 0.4;
}

</style>
